RDKit: RDKit::Dict Class Reference

| RDKit Open-source cheminformatics and machine learning.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | List of all members
RDKit::Dict Class Reference

The `Dict` class can be used to store objects of arbitrary type keyed by `strings`. More...

`#include <Dict.h>`

## Classes
struct | Pair

## Public Types
typedef std::vector< Pair > | DataType

## Public Member Functions
| Dict ()
| Dict (const Dict &other)
| ~Dict ()
void | update (const Dict &other, bool preserveExisting=false)
Dict & | operator= (const Dict &other)
const DataType & | getData () const
| Access to the underlying data. More...
DataType & | getData ()
bool | hasVal (const std::string &what) const
| Returns whether or not the dictionary contains a particular key. More...
STR_VECT | keys () const
| Returns the set of keys in the dictionary. More...
template<typename T >
void | getVal (const std::string &what, T &res) const
| Gets the value associated with a particular key. More...
template<typename T >
T | getVal (const std::string &what) const
void | getVal (const std::string &what, std::string &res) const
template<typename T >
bool | getValIfPresent (const std::string &what, T &res) const
| Potentially gets the value associated with a particular key returns true on success/false on failure. More...
bool | getValIfPresent (const std::string &what, std::string &res) const
template<typename T >
void | setVal (const std::string &what, T &val)
| Sets the value associated with a key. More...
template<typename T >
void | setPODVal (const std::string &what, T val)
void | setVal (const std::string &what, bool val)
void | setVal (const std::string &what, double val)
void | setVal (const std::string &what, float val)
void | setVal (const std::string &what, int val)
void | setVal (const std::string &what, unsigned int val)
void | setVal (const std::string &what, const char *val)
void | clearVal (const std::string &what)
| Clears the value associated with a particular key, removing the key from the dictionary. More...
void | reset ()
| Clears all keys (and values) from the dictionary. More...

## Detailed Description

The `Dict` class can be used to store objects of arbitrary type keyed by `strings`.

The actual storage is done using `RDValue` objects.

Definition at line 35 of file Dict.h.

## Member Typedef Documentation

typedef std::vector<Pair> RDKit::Dict::DataType

Definition at line 46 of file Dict.h.

## Constructor & Destructor Documentation

RDKit::Dict::Dict | ( |  | ) |
| inline

Definition at line 48 of file Dict.h.

RDKit::Dict::Dict | ( | const Dict & | other | ) |
| inline

Definition at line 50 of file Dict.h.

References RDKit::copy_rdvalue(), and RDKit::Dict::Pair::val.

RDKit::Dict::~Dict | ( |  | ) |
| inline

Definition at line 62 of file Dict.h.

References reset().

## Member Function Documentation

void RDKit::Dict::clearVal | ( | const std::string & | what | ) |
| inline

Clears the value associated with a particular key, removing the key from the dictionary.

Parameters

  what | the key to clear

Notes:

- If the dictionary does not contain the key `what`, a KeyErrorException will be thrown.

Definition at line 266 of file Dict.h.

References RDKit::RDValue::cleanup_rdvalue().

Referenced by RDKit::RDProps::clearComputedProps(), RDKit::MolCatalogEntry::clearProp(), RDKit::FragCatalogEntry::clearProp(), RDKit::RDProps::clearProp(), and RDKit::FilterCatalogEntry::clearProp().

const DataType& RDKit::Dict::getData | ( |  | ) | const
| inline

Access to the underlying data.

Definition at line 110 of file Dict.h.

Referenced by RDKit::streamReadProps().

DataType& RDKit::Dict::getData | ( |  | ) |
| inline

Definition at line 111 of file Dict.h.

template<typename T >

void RDKit::Dict::getVal | ( | const std::string & | what,
|  | T & | res
| ) |  | const
| inline

Gets the value associated with a particular key.

Parameters

  what | the key to lookup
  res | a reference used to return the result

Notes:

- If `res` is a `std::string`, every effort will be made to convert the specified element to a string using the `boost::lexical_cast` machinery.
- If the dictionary does not contain the key `what`, a KeyErrorException will be thrown.

Definition at line 152 of file Dict.h.

Referenced by RDKit::MolCatalogEntry::getProp(), RDKit::FragCatalogEntry::getProp(), RDKit::RDProps::getProp(), RDKit::FilterCatalogEntry::getProp(), and getVal().

template<typename T >

T RDKit::Dict::getVal | ( | const std::string & | what | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 157 of file Dict.h.

References getVal(), and RDKit::Dict::Pair::key.

void RDKit::Dict::getVal | ( | const std::string & | what,
|  | std::string & | res
| ) |  | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

template<typename T >

bool RDKit::Dict::getValIfPresent | ( | const std::string & | what,
|  | T & | res
| ) |  | const
| inline

Potentially gets the value associated with a particular key returns true on success/false on failure.

Parameters

  what | the key to lookup
  res | a reference used to return the result

Notes:

- If `res` is a `std::string`, every effort will be made to convert the specified element to a string using the `boost::lexical_cast` machinery.
- If the dictionary does not contain the key `what`, a KeyErrorException will be thrown.

Definition at line 185 of file Dict.h.

References RDKit::Dict::Pair::key.

Referenced by RDKit::RDProps::getPropIfPresent(), RDKit::FilterCatalogEntry::getPropIfPresent(), and RDKit::FilterCatalogEntry::hasFilterMatch().

bool RDKit::Dict::getValIfPresent | ( | const std::string & | what,
|  | std::string & | res
| ) |  | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

bool RDKit::Dict::hasVal | ( | const std::string & | what | ) | const
| inline

Returns whether or not the dictionary contains a particular key.

Definition at line 117 of file Dict.h.

References RDKit::Dict::Pair::key.

Referenced by RDKit::MolCatalogEntry::hasProp(), RDKit::FragCatalogEntry::hasProp(), RDKit::RDProps::hasProp(), and RDKit::FilterCatalogEntry::hasProp().

STR_VECT RDKit::Dict::keys | ( |  | ) | const
| inline

Returns the set of keys in the dictionary.

Returns
  a `STR_VECT`

Definition at line 129 of file Dict.h.

Referenced by RDKit::RDProps::getPropList(), RDKit::FilterCatalogEntry::getPropList(), and RDKit::FilterCatalogEntry::hasFilterMatch().

Dict& RDKit::Dict::operator= | ( | const Dict & | other | ) |
| inline

Definition at line 93 of file Dict.h.

References RDKit::copy_rdvalue(), and RDKit::Dict::Pair::val.

void RDKit::Dict::reset | ( |  | ) |
| inline

Clears all keys (and values) from the dictionary.

Definition at line 282 of file Dict.h.

References RDKit::RDValue::cleanup_rdvalue(), and RDKit::Dict::Pair::val.

Referenced by RDKit::RDProps::clear(), RDKit::RWMol::clear(), RDKit::FilterCatalogEntry::hasFilterMatch(), and ~Dict().

template<typename T >

void RDKit::Dict::setPODVal | ( | const std::string & | what,
|  | T | val
| ) |  |
| inline

Definition at line 225 of file Dict.h.

References RDKit::RDValue::cleanup_rdvalue(), RDKit::Dict::Pair::key, RDKit::Dict::Pair::Pair(), and RDKit::Dict::Pair::val.

Referenced by setVal().

template<typename T >

void RDKit::Dict::setVal | ( | const std::string & | what,
|  | T & | val
| ) |  |
| inline

Sets the value associated with a key.

Parameters

  what | the key to set
  val | the value to store

Notes:

- If `val` is a `const char *`, it will be converted to a `std::string` for storage.
- If the dictionary already contains the key `what`, the value will be replaced.

Definition at line 212 of file Dict.h.

References RDKit::RDValue::cleanup_rdvalue(), RDKit::Dict::Pair::key, RDKit::Dict::Pair::Pair(), and RDKit::Dict::Pair::val.

Referenced by RDKit::RWMol::clear(), RDKit::RDProps::clearComputedProps(), RDKit::RDProps::clearProp(), RDKit::FilterCatalogEntry::hasFilterMatch(), RDKit::MolCatalogEntry::setProp(), RDKit::RDProps::setProp(), RDKit::FragCatalogEntry::setProp(), RDKit::FilterCatalogEntry::setProp(), and setVal().

void RDKit::Dict::setVal | ( | const std::string & | what,
|  | bool | val
| ) |  |
| inline

Definition at line 237 of file Dict.h.

References setPODVal().

void RDKit::Dict::setVal | ( | const std::string & | what,
|  | double | val
| ) |  |
| inline

Definition at line 239 of file Dict.h.

References setPODVal().

void RDKit::Dict::setVal | ( | const std::string & | what,
|  | float | val
| ) |  |
| inline

Definition at line 241 of file Dict.h.

References setPODVal().

void RDKit::Dict::setVal | ( | const std::string & | what,
|  | int | val
| ) |  |
| inline

Definition at line 243 of file Dict.h.

References setPODVal().

void RDKit::Dict::setVal | ( | const std::string & | what,
|  | unsigned int | val
| ) |  |
| inline

Definition at line 245 of file Dict.h.

References setPODVal().

void RDKit::Dict::setVal | ( | const std::string & | what,
|  | const char * | val
| ) |  |
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 250 of file Dict.h.

References setVal().

void RDKit::Dict::update | ( | const Dict & | other,
|  | bool | preserveExisting = `false`
| ) |  |
| inline

Definition at line 66 of file Dict.h.

References RDKit::copy_rdvalue(), RDKit::Dict::Pair::key, RDKit::Dict::Pair::Pair(), and RDKit::Dict::Pair::val.

Referenced by RDKit::RDProps::updateProps().

The documentation for this class was generated from the following file:

- Dict.h